﻿using UnityEngine;
using UnityEngine.Events;

namespace Regeneration
{
    public class Regeneration
    {
        public static void Main()
        {
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Regeneration Syringe -FK",
                NameToOrderByOverride = "FK0,",
                DescriptionOverride = "Limb regrowth not included.",
                CategoryOverride = ModAPI.FindCategory("Biohazard"),
                ThumbnailOverride = ModAPI.LoadSprite("thumb.png", 1f, true),
                AfterSpawn = (System.Action<GameObject>)(Instance =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("regensyr.png", 1f, true);
                    Instance.GetComponent<SpriteRenderer>().color = Color.white;
                    UnityEngine.Object.Destroy((UnityEngine.Object)Instance.GetComponent<LifeSyringe>());
                    Instance.AddComponent<RegenerationSyringe>();
                })
            });
        }
        public static void OnLoad()
        {
            UnityEngine.Debug.Log("Debugged!");
        }
    }
}