﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Regeneration
{
    public class RegenerationPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return float.PositiveInfinity;
            }
        }

        public override float Lifespan
        {
            get
            {
                return float.PositiveInfinity;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            UnityEngine.Debug.Log("Regen injected!");
            this.StartCoroutine(this.Heal(this.Limb));

        }

        void update()
        {

        }

        private IEnumerator Heal(LimbBehaviour limb)
        {
            while (true)
            {
                UnityEngine.Debug.Log("Healing!");
                this.Limb.HealBone();
                this.Limb.Health = this.Limb.InitialHealth * 100f;
                this.Limb.Numbness = 0.0f;
                this.Limb.CirculationBehaviour.HealBleeding();
                this.Limb.CirculationBehaviour.IsPump = this.Limb.CirculationBehaviour.WasInitiallyPumping;
                this.Limb.CirculationBehaviour.BloodFlow = 50f;
                this.Limb.CirculationBehaviour.BloodAmount = 50f;
                this.Limb.BruiseCount = (ushort)0;
                this.Limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
                this.Limb.CirculationBehaviour.StabWoundCount = (ushort)0;
                this.Limb.Person.Consciousness = 1f;
                this.Limb.Person.OxygenLevel = 1f;
                this.Limb.Person.ShockLevel = 0f;
                this.Limb.Person.AdrenalineLevel = 0f;
                this.StartCoroutine(this.HealBurn(this.Limb));
                this.StartCoroutine(this.HealBulletHoles(this.Limb));
                this.StartCoroutine(this.HealWounds(this.Limb));
                this.StartCoroutine(this.HealRottenFlesh(this.Limb));
                this.StartCoroutine(this.HealAcidFlesh(this.Limb));
                yield return new WaitForSeconds(1f);
            }
            this.StartCoroutine(this.Heal(this.Limb));
        }

        private IEnumerator HealBurn(LimbBehaviour limb)
        {
            while ((double)limb.PhysicalBehaviour.BurnProgress > 0.100000001490116)
            {
                limb.PhysicalBehaviour.BurnProgress -= Time.deltaTime * 0.16f;
                yield return (object)new WaitForEndOfFrame();
            }
            limb.PhysicalBehaviour.BurnProgress = 0.0f;
        }

        private IEnumerator HealAcidFlesh(LimbBehaviour limb)
        {
            while ((double)limb.SkinMaterialHandler.AcidProgress > 0.100000001490116)
            {
                limb.SkinMaterialHandler.AcidProgress -= Time.deltaTime * 0.8f;
                yield return (object)new WaitForEndOfFrame();
            }
            limb.SkinMaterialHandler.AcidProgress = 0.0f;
        }

        private IEnumerator HealRottenFlesh(LimbBehaviour limb)
        {
            while ((double)limb.SkinMaterialHandler.RottenProgress > 0.100000001490116)
            {
                limb.SkinMaterialHandler.RottenProgress -= Time.deltaTime * 0.8f;
                yield return (object)new WaitForEndOfFrame();
            }
            limb.SkinMaterialHandler.RottenProgress = 0.0f;
        }


        private IEnumerator HealBulletHoles(LimbBehaviour limb)
        {
            while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.bulletHolePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
            {
                for (int index = 0; index < limb.SkinMaterialHandler.bulletHolePoints.Length; ++index)
                {
                    limb.SkinMaterialHandler.bulletHolePoints[index].z = Mathf.Max(limb.SkinMaterialHandler.bulletHolePoints[index].z, 0.05f);
                    limb.SkinMaterialHandler.bulletHolePoints[index].z += Time.deltaTime * 0.5f;
                }
                limb.SkinMaterialHandler.Sync();
                yield return (object)new WaitForEndOfFrame();
            }
        }

        private IEnumerator HealWounds(LimbBehaviour limb)
        {
            while ((double)((IEnumerable<Vector4>)limb.SkinMaterialHandler.damagePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
            {
                for (int index = 0; index < limb.SkinMaterialHandler.damagePoints.Length; ++index)
                    limb.SkinMaterialHandler.damagePoints[index].z += Time.deltaTime * 0.5f;
                limb.SkinMaterialHandler.Sync();
                yield return (object)new WaitForEndOfFrame();
            }
        }
    }
}